| Flutter Impeller |

Public Member Functions | List of all members
impeller::RectGeometry Class Referencefinal

`#include <rect_geometry.h>`

Inheritance diagram for impeller::RectGeometry:

## Public Member Functions
| RectGeometry (Rect rect)
| ~RectGeometry () override
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
bool | IsAxisAlignedRect () const override
GeometryResult | GetPositionBuffer (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
std::optional< Rect > | GetCoverage (const Matrix &transform) const override
Public Member Functions inherited from impeller::Geometry
virtual | ~Geometry ()
virtual GeometryResult::Mode | GetResultMode () const
virtual bool | CanApplyMaskFilter () const
virtual Scalar | ComputeAlphaCoverage (const Matrix &transform) const

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (const Rect &rect)
static std::unique_ptr< Geometry > | MakeOval (const Rect &rect)
static std::unique_ptr< Geometry > | MakeLine (const Point &p0, const Point &p1, Scalar width, Cap cap)
static std::unique_ptr< Geometry > | MakeCircle (const Point &center, Scalar radius)
static std::unique_ptr< Geometry > | MakeStrokedCircle (const Point &center, Scalar radius, Scalar stroke_width)
static std::unique_ptr< Geometry > | MakeRoundRect (const Rect &rect, const Size &radii)
static std::unique_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)
static Scalar | ComputeStrokeAlphaCoverage (const Matrix &entity, Scalar stroke_width)
| Compute an alpha value to simulate lower coverage of fractional pixel strokes. More...
Static Protected Member Functions inherited from impeller::Geometry
static GeometryResult | ComputePositionGeometry (const ContentContext &renderer, const Tessellator::VertexGenerator &generator, const Entity &entity, RenderPass &pass)

## Detailed Description

Definition at line 12 of file rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RectGeometry()

impeller::RectGeometry::RectGeometry | ( | Rect | rect | ) |
| explicit

Definition at line 9 of file rect_geometry.cc.

9 : rect_(rect) {}

## ◆ ~RectGeometry()

impeller::RectGeometry::~RectGeometry | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| overridevirtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 34 of file rect_geometry.cc.

34 {
35 if (!transform.IsTranslationScaleOnly()) {
36 return false;
37 }
38 Rect coverage = rect_.TransformBounds(transform);
39 return coverage.Contains(rect);
40 }

References impeller::TRect< T >::Contains(), transform, and impeller::TRect< T >::TransformBounds().

## ◆ GetCoverage()

std::optional< Rect > impeller::RectGeometry::GetCoverage | ( | const Matrix & | transform | ) | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 30 of file rect_geometry.cc.

30 {
31 return rect_.TransformBounds(transform);
32 }

References transform, and impeller::TRect< T >::TransformBounds().

## ◆ GetPositionBuffer()

GeometryResult impeller::RectGeometry::GetPositionBuffer | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| overridevirtual

Implements impeller::Geometry.

Definition at line 13 of file rect_geometry.cc.

15 {
16 auto& host_buffer = renderer.GetTransientsBuffer();
17 return GeometryResult{
18 .type = PrimitiveType::kTriangleStrip,
19 .vertex_buffer =
20 {
21 .vertex_buffer = host_buffer.Emplace(
22 rect_.GetPoints().data(), 8 * sizeof(float), alignof(float)),
23 .vertex_count = 4,
24 .index_type = IndexType::kNone,
25 },
26 .transform = entity.GetShaderTransform(pass),
27 };
28 }

References impeller::TRect< T >::GetPoints(), impeller::Entity::GetShaderTransform(), impeller::ContentContext::GetTransientsBuffer(), impeller::kNone, impeller::kTriangleStrip, and impeller::GeometryResult::type.

## ◆ IsAxisAlignedRect()

bool impeller::RectGeometry::IsAxisAlignedRect | ( |  | ) | const
| overridevirtual

Reimplemented from impeller::Geometry.

Definition at line 42 of file rect_geometry.cc.

42 {
43 return true;
44 }

The documentation for this class was generated from the following files:

- impeller/entity/geometry/rect_geometry.h
- impeller/entity/geometry/rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:466
impeller::TRect::GetPoints
constexpr std::array< TPoint< T >, 4 > GetPoints() const
Get the points that represent the 4 corners of this rectangle in a Z order that is compatible with tr...
Definition: rect.h:408
impeller::PrimitiveType::kTriangleStrip
@ kTriangleStrip
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:213
impeller::IndexType::kNone
@ kNone
Does not use the index buffer.
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:776
impeller::TRect::Contains
constexpr bool Contains(const TPoint< Type > &p) const
Returns true iff the provided point |p| is inside the half-open interior of this rectangle.
Definition: rect.h:225